shakespeare-2.0.7: A toolkit for making compile-time interpolated templates

Safe Haskell | None
Language | Haskell98

Text.Shakespeare

Contents

- low-level
- Internal

Description

NOTE: This module should be considered internal, and will be hidden in future releases.

Synopsis

- data ShakespeareSettings = ShakespeareSettings {
  - varChar :: Char
  - urlChar :: Char
  - intChar :: Char
  - toBuilder :: Exp
  - wrap :: Exp
  - unwrap :: Exp
  - justVarInterpolation :: Bool
  - preConversion :: Maybe PreConvert
  - modifyFinalValue :: Maybe Exp
  }
- data PreConvert = PreConvert {
  - preConvert :: PreConversion
  - preEscapeIgnoreBalanced :: [Char]
  - preEscapeIgnoreLine :: [Char]
  - wrapInsertion :: Maybe WrapInsertion
  }
- data WrapInsertion = WrapInsertion {
  - wrapInsertionIndent :: Maybe String
  - wrapInsertionStartBegin :: String
  - wrapInsertionSeparator :: String
  - wrapInsertionStartClose :: String
  - wrapInsertionEnd :: String
  - wrapInsertionAddParens :: Bool
  }
- data PreConversion
  - = ReadProcess String [String]
  - | Id
- defaultShakespeareSettings :: ShakespeareSettings
- shakespeare :: ShakespeareSettings -> QuasiQuoter
- shakespeareFile :: ShakespeareSettings -> FilePath -> Q Exp
- shakespeareFileReload :: ShakespeareSettings -> FilePath -> Q Exp
- shakespeareFromString :: ShakespeareSettings -> String -> Q Exp
- shakespeareUsedIdentifiers :: ShakespeareSettings -> String -> [(Deref, VarType)]
- type RenderUrl url = url -> QueryParameters -> Text
- data VarType
  - = VTPlain
  - | VTUrl
  - | VTUrlParam
  - | VTMixin
- data Deref
- type Parser = Parsec String [String]
- preFilter :: Maybe FilePath -> ShakespeareSettings -> String -> IO String
- shakespeareRuntime :: ShakespeareSettings -> FilePath -> [(Deref, VarExp url)] -> Shakespeare url
- pack' :: String -> Text

# Documentation

data ShakespeareSettings Source

Constructors

ShakespeareSettings |

Fields

varChar :: Char
urlChar :: Char
intChar :: Char
toBuilder :: Exp
wrap :: Exp
unwrap :: Exp
justVarInterpolation :: Bool
preConversion :: Maybe PreConvert
modifyFinalValue :: Maybe Exp

  A transformation applied to the final expression. Most often, this would be used to force the type of the expression to help make more meaningful error messages.

Instances

Lift ShakespeareSettings Source |

data PreConvert Source

Coffeescript, TypeScript, and other languages compiles down to Javascript. Previously we waited until the very end, at the rendering stage to perform this compilation. Lets call is a post-conversion This had the advantage that all Haskell values were inserted first: for example a value could be inserted that Coffeescript would compile into Javascript. While that is perhaps a safer approach, the advantage is not used in practice: it was that way mainly for ease of implementation. The down-side is the template must be compiled down to Javascript during every request. If instead we do a pre-conversion to compile down to Javascript, we only need to perform the compilation once.

The problem then is the insertion of Haskell values: we need a hole for them. This can be done with variables known to the language. During the pre-conversion we first modify all Haskell insertions So #{a} is change to shakespeare_var_a Then we can place the Haskell values in a function wrapper that exposes those variables: (function(shakespeare_var_a){ ... shakespeare_var_a ...}) TypeScript can compile that, and then we tack an application of the Haskell values onto the result: (#{a})

preEscapeIgnoreBalanced is used to not insert backtacks for variable already inside strings or backticks. coffeescript will happily ignore the interpolations, and backticks would not be treated as escaping in that context. preEscapeIgnoreLine was added to ignore comments (which in Coffeescript begin with a '#')

Constructors

PreConvert |

Fields

preConvert :: PreConversion
preEscapeIgnoreBalanced :: [Char]
preEscapeIgnoreLine :: [Char]
wrapInsertion :: Maybe WrapInsertion

Instances

Lift PreConvert Source |

data WrapInsertion Source

Constructors

WrapInsertion |

Fields

wrapInsertionIndent :: Maybe String
wrapInsertionStartBegin :: String
wrapInsertionSeparator :: String
wrapInsertionStartClose :: String
wrapInsertionEnd :: String
wrapInsertionAddParens :: Bool

Instances

Lift WrapInsertion Source |

data PreConversion Source

Constructors

ReadProcess String [String] |
Id |

Instances

Lift PreConversion Source |

defaultShakespeareSettings :: ShakespeareSettings Source

shakespeare :: ShakespeareSettings -> QuasiQuoter Source

shakespeareFile :: ShakespeareSettings -> FilePath -> Q Exp Source

shakespeareFileReload :: ShakespeareSettings -> FilePath -> Q Exp Source

# low-level

shakespeareFromString :: ShakespeareSettings -> String -> Q Exp Source

shakespeareUsedIdentifiers :: ShakespeareSettings -> String -> [(Deref, VarType)] Source

Determine which identifiers are used by the given template, useful for creating systems like yesod devel.

type RenderUrl url = url -> QueryParameters -> Text Source

data VarType Source

Constructors

VTPlain |
VTUrl |
VTUrlParam |
VTMixin |

Instances

Bounded VarType Source |
Enum VarType Source |
Eq VarType Source |
Data VarType Source |
Ord VarType Source |
Show VarType Source |
Generic VarType Source |
type Rep VarType Source |

data Deref Source

Instances

Eq Deref Source |
Data Deref Source |
Ord Deref Source |
Read Deref Source |
Show Deref Source |
Lift Deref Source |

type Parser = Parsec String [String] Source

A parser with a user state of [String]

preFilter Source

Arguments

:: Maybe FilePath | for error reporting
-> ShakespeareSettings |
-> String |
-> IO String |

# Internal

shakespeareRuntime :: ShakespeareSettings -> FilePath -> [(Deref, VarExp url)] -> Shakespeare url Source

pack' :: String -> Text Source